#include "SceneEntity.h"
#include "glInterface.h"
#include "Geometry.h"
#include "Material.h"
#include "RenderState.h"
#include "Shape.h"
#include <Cg/cg.h>
#include <Cg/cgGL.h>


namespace CHCDemoEngine 
{

SceneEntity::SceneEntity(Transform3 *trafo): mTransform(trafo)
{
}


SceneEntity::~SceneEntity()
{
}


ShapeContainer *SceneEntity::GetCurrentLOD()
{
/*	if (mLODInfos->empty())
		return &mShapes;

	float mDistance = 0.0f;

	int i = 0;

	for (int i = 0; i < mLODInfos->size(); ++ i)
	{
		if ((mLODInfos*)[i].mDistance > mDistance)
			return &(mLODInfos*)[i].mShapes;
	}

	return &(mLODInfos->last().mShapes);
	*/
	return NULL;
}


void SceneEntity::Render(RenderState *state)
{
	//if (mMaterial) mMaterial->Render(state);
	float mDistance = 0.0f;

	ShapeContainer *shapes;

	shapes = GetCurrentLOD();

	for (int i = 0; i < shapes->size(); ++ i)
	{
		(*shapes)[i]->Render(state);
	}
}


void SceneEntity::AddShape(Shape *shape)
{
	mShapes.push_back(shape);
}


void SceneEntity::SetTransform(Transform3 *trafo)
{
	mTransform = trafo;
}


void SceneEntity::SetLastRendered(int lastRendered)
{
	mLastRendered = lastRendered;
}


int SceneEntity::GetLastRendered() const
{
	return mLastRendered;
}


AxisAlignedBox3 SceneEntity::GetBoundingBox() const
{
#ifdef TODO
	AxisAlignedBox3 box = mGeometry->GetBoundingBox();
	if (mTransform) Transform(box, *mTransform);
#else
	AxisAlignedBox3 box;
#endif
	

	return box;
}


}