#include "Shape.h"
#include "Material.h"
#include "RenderState.h"
#include "Geometry.h"
#include "SceneEntity.h"

#include "glInterface.h"
#include <Cg/cg.h>
#include <Cg/cgGL.h>


namespace CHCDemoEngine 
{

Shape::Shape(Geometry *geometry, Material *mat, SceneEntity *parent):
mGeometry(geometry), 
mMaterial(mat), 
mParent(parent), 
mRenderQueueBucket(NULL)
{
}


Shape::~Shape()
{}


void Shape::Render(RenderState *state)
{
	if (mMaterial) mMaterial->Render(state);

	mGeometry->Render(state);
}


void Shape::SetGeometry(Geometry *geom)
{
	mGeometry = geom;
}


void Shape::SetMaterial(Material *mat)
{
	mMaterial = mat;
}


}